#ifndef CHEATSFILE_H
#define CHEATSFILE_H

#include <stdint.h>

typedef struct {
	uint32_t addr;
	uint32_t value;
} code_t;

typedef struct {
	char *name;
	int16_t numOfCodes;

	code_t *code;
} xplSaveCheats_t;

typedef struct {
	char *title;
	int16_t numOfCheats;

	xplSaveCheats_t *cheat;
} xplSaveGames_t;

typedef struct {
	int32_t dataSize;
	uint32_t checkSum;
} xplSaveHeader_t;

typedef struct {
	/* used for converting */
	int32_t numOfGames;

	xplSaveHeader_t header;
	xplSaveGames_t game[1024];
} xplSave_t;

typedef struct {
	int16_t numOfCodes;
	uint8_t nameLen;
	char *name;

	code_t *code;
} smSaveCheats_t;

typedef struct {
	int16_t numOfCheats;
	uint8_t titleLen;
	char *title;

	smSaveCheats_t *cheat;

} smSaveGames_t;

typedef struct {
	uint32_t checkSum;
	int32_t dataSize;
	int32_t numOfGames;
	int32_t cheatsTotal;
	int32_t codesTotal;
} smSaveHeader_t;

typedef struct {
	smSaveHeader_t header;
	smSaveGames_t *game;
} smSave_t;

#endif
